Index: LMDZ.3.3/tags/CCM1_0/libf/phylmd/clmain.F
===================================================================
--- LMDZ.3.3/branches/LF/libf/phylmd/clmain.F	(revision 3)
+++ LMDZ.3.3/tags/CCM1_0/libf/phylmd/clmain.F	(revision 300)
@@ -1,9 +1,19 @@
-      SUBROUTINE clmain(dtime,pctsrf,t,q,u,v,
-     .                  soil_model,ts,soilcap,soilflux,
-     .                  paprs,pplay,radsol,snow,qsol,
-     .                  xlat, rugos,
+c
+c $Header$
+c
+
+      SUBROUTINE clmain(dtime,itap,date0,pctsrf,
+     .                  t,q,u,v,
+     .                  jour, rmu0,
+     .                  ok_veget, ocean, npas, nexca, ts,
+     .                  soil_model,ftsoil,
+     .                  paprs,pplay,radsol,snow,qsol,evap,albe,alblw,
+     .                  fluxlat,
+     .                  rain_f, snow_f, solsw, sollw, sollwdown, fder,
+     .                  rlon, rlat, cufi, cvfi, rugos,
+     .                  debut, lafin, agesno,rugoro,
      .                  d_t,d_q,d_u,d_v,d_ts,
      .                  flux_t,flux_q,flux_u,flux_v,cdragh,cdragm,
-     .                  rugmer, dflux_t,dflux_q,
+     .                  dflux_t,dflux_q,
      .                  zcoefh,zu1,zv1)
 cAA .                  itr, tr, flux_surf, d_tr)
@@ -23,5 +33,6 @@
 cAA il faudra sortir ces memes champs en leur ajoutant une dimension, 
 cAA c'est a dire nbsrf (nbre de subsurface).
- 
+      USE ioipsl
+      USE interface_surf
       IMPLICIT none
 c======================================================================
@@ -30,4 +41,6 @@
 c Arguments:
 c dtime----input-R- interval du temps (secondes)
+c itap-----input-I- numero du pas de temps
+c date0----input-R- jour initial
 c t--------input-R- temperature (K)
 c q--------input-R- vapeur d'eau (kg/kg)
@@ -38,9 +51,8 @@
 c pplay----input-R- pression au milieu de couche (Pa)
 c radsol---input-R- flux radiatif net (positif vers le sol) en W/m**2
-c capsol---input-R- inversion de l'effective capacite du sol (J/m2/K)
-c beta-----input-R- coefficient de l'evaporation reelle (0 a 1)
-c dif_grnd-input-R- coeff. de diffusion (chaleur) vers le sol profond
-c xlat-----input-R- latitude en degree
+c rlat-----input-R- latitude en degree
 c rugos----input-R- longeur de rugosite (en m)
+c cufi-----input-R- resolution des mailles en x (m)
+c cvfi-----input-R- resolution des mailles en y (m)
 c
 c d_t------output-R- le changement pour "t"
@@ -54,5 +66,4 @@
 c flux_u---output-R- tension du vent X: (kg m/s)/(m**2 s) ou Pascal
 c flux_v---output-R- tension du vent Y: (kg m/s)/(m**2 s) ou Pascal
-c rugmer---output-R- longeur de rugosite sur mer (m)
 c dflux_t derive du flux sensible
 c dflux_q derive du flux latent
@@ -68,19 +79,26 @@
 #include "dimphy.h"
 #include "indicesol.h"
-c
-      LOGICAL soil_model
+c$$$ PB ajout pour soil
+#include "dimsoil.h"
 c
       REAL dtime
+      real date0
+      integer itap
       REAL t(klon,klev), q(klon,klev)
       REAL u(klon,klev), v(klon,klev)
       REAL paprs(klon,klev+1), pplay(klon,klev), radsol(klon)
-      REAL xlat(klon)
+      REAL rlon(klon), rlat(klon), cufi(klon), cvfi(klon)
       REAL d_t(klon, klev), d_q(klon, klev)
       REAL d_u(klon, klev), d_v(klon, klev)
-      REAL flux_t(klon,klev), flux_q(klon,klev)
+      REAL flux_t(klon,klev, nbsrf), flux_q(klon,klev, nbsrf)
       REAL dflux_t(klon), dflux_q(klon)
-      REAL flux_u(klon,klev), flux_v(klon,klev)
-      REAL rugmer(klon)
+      REAL flux_u(klon,klev, nbsrf), flux_v(klon,klev, nbsrf)
+      REAL rugmer(klon), agesno(klon,nbsrf),rugoro(klon)
       REAL cdragh(klon), cdragm(klon)
+      integer jour            ! jour de l'annee en cours
+      real rmu0(klon)         ! cosinus de l'angle solaire zenithal
+      LOGICAL debut, lafin, ok_veget
+      character*6 ocean
+      integer npas, nexca
 cAA      INTEGER itr
 cAA      REAL tr(klon,klev,nbtr)
@@ -93,5 +111,16 @@
       REAL snow(klon,nbsrf)
       REAL qsol(klon,nbsrf)
+      REAL evap(klon,nbsrf)
+      REAL albe(klon,nbsrf)
+      REAL alblw(klon,nbsrf)
+c$$$ PB
+      REAL fluxlat(klon,nbsrf)
+C
+      real rain_f(klon), snow_f(klon)
+      REAL fder(klon)
+      REAL sollw(klon), solsw(klon), sollwdown(klon)
       REAL rugos(klon,nbsrf)
+C la nouvelle repartition des surfaces sortie de l'interface
+      REAL pctsrf_new(klon,nbsrf)
 cAA
       REAL zcoefh(klon,klev)
@@ -99,11 +128,23 @@
       REAL zv1(klon)
 cAA
+c$$$ PB ajout pour soil
+      LOGICAL soil_model
+      REAL ftsoil(klon,nsoilmx,nbsrf)
+      REAL ytsoil(klon,nsoilmx)
 c======================================================================
       EXTERNAL clqh, clvent, coefkz, calbeta, cltrac
 c======================================================================
-      REAL yts(klon), yrugos(klon), ypct(klon)
-      REAL ycal(klon), ybeta(klon), ydif(klon)
+      REAL yts(klon), yrugos(klon), ypct(klon), yz0_new(klon)
+      REAL yalb(klon)
+      REAL yalblw(klon)
       REAL yu1(klon), yv1(klon)
-      REAL yrugm(klon), yrads(klon)
+      real ysnow(klon), yqsol(klon), yagesno(klon)
+      real yrain_f(klon), ysnow_f(klon)
+      real ysollw(klon), ysolsw(klon), ysollwdown(klon)
+      real yfder(klon), ytaux(klon), ytauy(klon)
+      REAL yrugm(klon), yrads(klon),yrugoro(klon)
+c$$$ PB
+      REAL yfluxlat(klon)
+C
       REAL y_d_ts(klon)
       REAL y_d_t(klon, klev), y_d_q(klon, klev)
@@ -113,6 +154,4 @@
       REAL y_dflux_t(klon), y_dflux_q(klon)
       REAL ycoefh(klon,klev), ycoefm(klon,klev)
-      REAL ygamt(klon,2:klev) ! contre-gradient pour temperature
-      REAL ygamq(klon,2:klev) ! contre-gradient pour humidite
       REAL yu(klon,klev), yv(klon,klev)
       REAL yt(klon,klev), yq(klon,klev)
@@ -122,7 +161,9 @@
 cAA      REAL yflxsrf(klon,nbtr)
 c
+      LOGICAL contreg
+      PARAMETER (contreg=.TRUE.)
+c
       LOGICAL ok_nonloc
       PARAMETER (ok_nonloc=.FALSE.)
-      REAL y_cd_h(klon), y_cd_m(klon)
       REAL ycoefm0(klon,klev), ycoefh0(klon,klev)
 c
@@ -130,14 +171,65 @@
       REAL u1lay(klon), v1lay(klon)
       REAL delp(klon,klev)
-      REAL capsol(klon), beta(klon), dif_grnd(klon)
-      REAL cal(klon)
-      REAL soilcap(klon,nbsrf), soilflux(klon,nbsrf)
       REAL totalflu(klon)
       INTEGER i, k, nsrf 
 cAA   INTEGER it
       INTEGER ni(klon), knon, j
+c Introduction d'une variable "pourcentage potentiel" pour tenir compte
+c des eventuelles apparitions et/ou disparitions de la glace de mer
+      REAL pctsrf_pot(klon,nbsrf)
+      
 c======================================================================
       REAL zx_alf1, zx_alf2 !valeur ambiante par extrapola.
 c======================================================================
+c
+c maf pour sorties IOISPL en cas de debugagage
+c
+      CHARACTER*80 cldebug
+      SAVE cldebug
+      CHARACTER*8 cl_surf(nbsrf)
+      SAVE cl_surf
+      INTEGER nhoridbg, nidbg
+      SAVE nhoridbg, nidbg
+      INTEGER ndexbg(iim*(jjm+1))
+      REAL zx_lon(iim,jjm+1), zx_lat(iim,jjm+1), zjulian
+      REAL tabindx(klon)
+      REAL debugtab(iim,jjm+1)
+      LOGICAL first_appel
+      SAVE first_appel
+      DATA first_appel/.false./
+      LOGICAL debugindex
+      SAVE debugindex
+      DATA debugindex/.false./
+#include "temps.h"
+      
+      IF (first_appel) THEN
+          first_appel=.false.
+!
+! initialisation sorties netcdf
+!
+          CALL ymds2ju(anne_ini, 1, 1, 0.0, zjulian)
+          zjulian = zjulian + day_ini
+          CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlon,zx_lon)
+          DO i = 1, iim
+            zx_lon(i,1) = rlon(i+1)
+            zx_lon(i,jjm+1) = rlon(i+1)
+          ENDDO
+          CALL gr_fi_ecrit(1,klon,iim,jjm+1,rlat,zx_lat)
+          cldebug='sous_index'
+          CALL histbeg(cldebug, iim,zx_lon,jjm+1,zx_lat,1,iim,1,jjm
+     $        +1, 0,zjulian,dtime,nhoridbg,nidbg) 
+! no vertical axis
+          cl_surf(1)='ter'
+          cl_surf(2)='lic'
+          cl_surf(3)='oce'
+          cl_surf(4)='sic'
+          DO nsrf=1,nbsrf
+            CALL histdef(nidbg, cl_surf(nsrf),cl_surf(nsrf), "-",iim,
+     $          jjm+1,nhoridbg, 1, 1, 1, -99, 32, "inst", dtime,dtime) 
+          END DO
+          CALL histend(nidbg)
+          CALL histsync(nidbg)
+      ENDIF 
+          
       DO k = 1, klev   ! epaisseur de couche
       DO i = 1, klon
@@ -164,19 +256,60 @@
          zv1(i) = 0.0
       ENDDO
+      ypct = 0.0
+      yts = 0.0
+      ysnow = 0.0
+      yqsol = 0.0
+      yalb = 0.0
+      yalblw = 0.0
+      yrain_f = 0.0
+      ysnow_f = 0.0
+      yfder = 0.0
+      ytaux = 0.0
+      ytauy = 0.0
+      ysolsw = 0.0
+      ysollw = 0.0
+      ysollwdown = 0.0
+      yrugos = 0.0
+      yu1 = 0.0
+      yv1 = 0.0
+      yrads = 0.0
+      ypaprs = 0.0
+      ypaprs = 0.0
+      ypplay = 0.0
+      ydelp = 0.0
+      yu = 0.0
+      yv = 0.0
+      yt = 0.0
+      yq = 0.0
+      pctsrf_new = 0.0
+      y_flux_u = 0.0
+      y_flux_v = 0.0
+C$$ PB
+      y_dflux_t = 0.0
+      y_dflux_q = 0.0
+      ytsoil = 999999.
+      yrugoro = 0.
+
       DO nsrf = 1, nbsrf
       DO i = 1, klon
          d_ts(i,nsrf) = 0.0
       ENDDO
-      ENDDO
+      END DO
+C§§§ PB
+      yfluxlat=0.
+      flux_t = 0.
+      flux_q = 0.
+      flux_u = 0.
+      flux_v = 0.
       DO k = 1, klev
       DO i = 1, klon
          d_t(i,k) = 0.0
          d_q(i,k) = 0.0
-         flux_t(i,k) = 0.0
-         flux_q(i,k) = 0.0
+c$$$         flux_t(i,k) = 0.0
+c$$$         flux_q(i,k) = 0.0
          d_u(i,k) = 0.0
          d_v(i,k) = 0.0
-         flux_u(i,k) = 0.0
-         flux_v(i,k) = 0.0
+c$$$         flux_u(i,k) = 0.0
+c$$$         flux_v(i,k) = 0.0
          zcoefh(i,k) = 0.0
       ENDDO
@@ -191,27 +324,19 @@
 cAA      ENDDO
 cAA      ENDIF
+
 c
 c Boucler sur toutes les sous-fractions du sol:
 c
+C Initialisation des "pourcentages potentiels". On considere ici qu'on 
+C peut avoir potentiellementdela glace sur tout le domaine oceanique 
+C (a affiner)
+
+      pctsrf_pot = pctsrf
+      pctsrf_pot(:,is_oce) = 1. - zmasq(:)
+      pctsrf_pot(:,is_sic) = 1. - zmasq(:)
+
       DO 99999 nsrf = 1, nbsrf
-c
-c prescrire les proprietes du sol:
-      CALL calbeta(dtime,nsrf,snow,qsol, beta,capsol,dif_grnd)
-      IF (.NOT.soil_model) THEN
-         DO i = 1, klon
-            cal(i) = RCPD * capsol(i)
-            totalflu(i) = radsol(i)
-         ENDDO
-      ELSE
-         DO i = 1, klon
-            totalflu(i) = soilflux(i,nsrf) + radsol(i)
-            IF (nsrf.EQ.is_oce) THEN
-               cal(i) = 0.0
-            ELSE
-               cal(i) = RCPD / soilcap(i,nsrf)
-            ENDIF
-         ENDDO
-      ENDIF
-c
+       totalflu = radsol
+
 c chercher les indices:
       DO j = 1, klon
@@ -220,5 +345,8 @@
       knon = 0
       DO i = 1, klon
-      IF (pctsrf(i,nsrf).GT.epsfra) THEN
+
+C pour determiner le domaine a traiter on utilise les surfaces "potentielles"
+C  
+      IF (pctsrf_pot(i,nsrf).GT.epsfra) THEN
          knon = knon + 1
          ni(knon) = i
@@ -226,4 +354,20 @@
       ENDDO
 c
+c      write(*,*)'CLMAIN, nsrf, knon =',nsrf, knon
+c
+c variables pour avoir une sortie IOIPSL des INDEX
+c
+      IF (debugindex) THEN 
+          tabindx(:)=0.
+c          tabindx(1:knon)=(/FLOAT(i),i=1:knon/)
+          DO i=1,knon
+            tabindx(1:knon)=FLOAT(i)
+          END DO 
+          debugtab(:,:)=0.
+          ndexbg(:)=0
+          CALL gath2cpl(tabindx,debugtab,klon,knon,iim,jjm,ni)
+          CALL histwrite(nidbg,cl_surf(nsrf),itap,debugtab,iim*(jjm+1)
+     $        ,ndexbg)
+      ENDIF 
       IF (knon.EQ.0) GOTO 99999
       DO j = 1, knon
@@ -231,13 +375,43 @@
         ypct(j) = pctsrf(i,nsrf)
         yts(j) = ts(i,nsrf)
+        ysnow(j) = snow(i,nsrf)
+        yqsol(j) = qsol(i,nsrf)
+        yalb(j) = albe(i,nsrf)
+        yalblw(j) = alblw(i,nsrf)
+        yrain_f(j) = rain_f(i)
+        ysnow_f(j) = snow_f(i)
+        yagesno(j) = agesno(i,nsrf)
+        yfder(j) = fder(i)
+        ytaux(j) = flux_u(i,1,nsrf)
+        ytauy(j) = flux_v(i,1,nsrf)
+c$$$        ysolsw(j) = solsw(i)
+       ysolsw(j) = (1 - albe(i,nsrf)) 
+     $      /(1 - pctsrf(i,is_ter) * albe(i,is_ter) 
+     $      - pctsrf(i, is_lic) *albe(i,is_lic) 
+     $      - pctsrf(i, is_oce) *albe(i,is_oce)
+     $      - pctsrf(i, is_sic) *albe(i,is_sic) 
+     $      ) * solsw(i)
+        ysollw(j) = sollw(i)
+        ysollwdown(j) = sollwdown(i)
         yrugos(j) = rugos(i,nsrf)
+        yrugoro(j) = rugoro(i)
         yu1(j) = u1lay(i)
         yv1(j) = v1lay(i)
-        yrads(j) = totalflu(i)
-        ycal(j) = cal(i)
-        ybeta(j) = beta(i)
-        ydif(j) = dif_grnd(i)
+c$$$        yrads(j) = totalflu(i)
+        yrads(j) = (1 - albe(i,nsrf)) 
+     $      /(1 - pctsrf(i,is_ter) * albe(i,is_ter) 
+     $      - pctsrf(i, is_lic) *albe(i,is_lic) 
+     $      - pctsrf(i, is_oce) *albe(i,is_oce)
+     $      - pctsrf(i, is_sic) *albe(i,is_sic) 
+     $      ) * solsw(i) + sollw(i)
         ypaprs(j,klev+1) = paprs(i,klev+1)
-      ENDDO
+      END DO
+c$$$ PB ajour pour soil
+      DO k = 1, nsoilmx
+        DO j = 1, knon
+          i = ni(j)
+          ytsoil(j,k) = ftsoil(i,k,nsrf)
+        END DO  
+      END DO 
       DO k = 1, klev
       DO j = 1, knon
@@ -253,18 +427,4 @@
       ENDDO
 c
-cAA      IF (itr.GE.1) THEN
-cAA      DO it = 1, itr
-cAA        DO k = 1, klev
-cAA        DO j = 1, knon
-cAA        i = ni(j)
-cAA          ytr(j,k,it) = tr(i,k,it)
-cAA        ENDDO
-cAA        ENDDO
-cAA        DO j = 1, knon
-cAA        i = ni(j)
-cAA          yflxsrf(j,it) = flux_surf(i,it)
-cAA        ENDDO
-cAA      ENDDO
-cAA      ENDIF
 c
 c calculer Cdrag et les coefficients d'echange
@@ -272,39 +432,14 @@
      .            yts, yrugos, yu, yv, yt, yq,
      .            ycoefm, ycoefh)
-c
-c parametrisation non-locale:
-      IF (ok_nonloc) THEN
-         DO i = 1, knon
-            y_cd_h(i) = ycoefh(i,1)
-            y_cd_m(i) = ycoefm(i,1)
-         ENDDO
-         CALL nonlocal(knon, ypaprs, ypplay,
-     .        yts,ybeta,yu,yv,yt,yq,
-     .        y_cd_h, y_cd_m, ycoefm0, ycoefh0, ygamt, ygamq)
-         DO k = 1, klev
-         DO i = 1, knon
-            ycoefm(i,k) = MAX(ycoefm(i,k),ycoefm0(i,k))
-            ycoefh(i,k) = MAX(ycoefh(i,k),ycoefh0(i,k))
-         ENDDO
-         ENDDO
-      ELSE
-         DO k = 3, klev
-         DO i = 1, knon
-            ygamq(i,k) = 0.0
-            ygamt(i,k) = -1.0E-03
-         ENDDO
-         ENDDO
-         DO i = 1, knon
-            ygamq(i,2) = 0.0
-            ygamt(i,2) = -2.5E-03
-         ENDDO
-      ENDIF
-c
-c calculer la diffusion de "q" et de "h"
-      CALL clqh(knon, dtime, yu1, yv1,
-     e          ycoefh,yt,yq,yts,ypaprs,ypplay,ydelp,yrads,
-     e          ycal,ybeta,ydif,ygamt,ygamq,
-     s          y_d_t, y_d_q, y_d_ts, 
-     s          y_flux_t, y_flux_q, y_dflux_t, y_dflux_q)
+      CALL coefkz2(nsrf, knon, ypaprs, ypplay,yt,
+     .                  ycoefm0, ycoefh0)
+      DO k = 1, klev
+      DO i = 1, knon
+         ycoefm(i,k) = MAX(ycoefm(i,k),ycoefm0(i,k))
+         ycoefh(i,k) = MAX(ycoefh(i,k),ycoefh0(i,k))
+      ENDDO
+      ENDDO
+
+c
 c
 c calculer la diffusion des vitesses "u" et "v"
@@ -313,6 +448,28 @@
       CALL clvent(knon,dtime,yu1,yv1,ycoefm,yt,yv,ypaprs,ypplay,ydelp,
      s            y_d_v,y_flux_v)
+
+c pour le couplage
+      ytaux = y_flux_u(:,1)
+      ytauy = y_flux_v(:,1)
+
+c calculer la diffusion de "q" et de "h"
+      CALL clqh(dtime, itap, date0,jour, debut,lafin,
+     e          rlon, rlat, cufi, cvfi,
+     e          knon, nsrf, ni, pctsrf,
+     e          soil_model, ytsoil,
+     e          ok_veget, ocean, npas, nexca,
+     e          rmu0, yrugos, yrugoro,
+     e          yu1, yv1, ycoefh,
+     e          yt,yq,yts,ypaprs,ypplay,
+     e          ydelp,yrads,yalb, yalblw, ysnow, yqsol, 
+     e          yrain_f, ysnow_f, yfder, ytaux, ytauy, 
+c$$$     e          ysollw, ysolsw,
+     e          ysollw, ysollwdown, ysolsw,yfluxlat,
+     s          pctsrf_new, yagesno,
+     s          y_d_t, y_d_q, y_d_ts, yz0_new,
+     s          y_flux_t, y_flux_q, y_dflux_t, y_dflux_q)
 c
 c calculer la longueur de rugosite sur ocean
+      yrugm=0.
       IF (nsrf.EQ.is_oce) THEN
       DO j = 1, knon
@@ -321,15 +478,4 @@
       ENDDO
       ENDIF
-c
-cAA MAINTENANT DANS PHYTRAC
-cAAc calculer la diffusion des traceurs
-cAA      IF (itr.GE.1) THEN
-cAA      DO it = 1, itr
-cAA      CALL cltrac(knon,dtime,ycoefh, yt, ytr(1,1,it), yflxsrf(1,it),
-cAA     e            ypaprs, ypplay, ydelp,
-cAA     s            y_d_tr(1,1,it))
-cAA      ENDDO
-cAA      ENDIF
-c
       DO j = 1, knon
          y_dflux_t(j) = y_dflux_t(j) * ypct(j)
@@ -340,22 +486,47 @@
 c
       DO k = 1, klev
+        DO j = 1, knon
+          i = ni(j)
+          ycoefh(j,k) = ycoefh(j,k) * ypct(j)
+          ycoefm(j,k) = ycoefm(j,k) * ypct(j)
+          y_d_t(j,k) = y_d_t(j,k) * ypct(j)
+          y_d_q(j,k) = y_d_q(j,k) * ypct(j)
+C§§§ PB
+          flux_t(i,k,nsrf) = y_flux_t(j,k)
+          flux_q(i,k,nsrf) = y_flux_q(j,k)
+          flux_u(i,k,nsrf) = y_flux_u(j,k)
+          flux_v(i,k,nsrf) = y_flux_v(j,k)
+c$$$ PB        y_flux_t(j,k) = y_flux_t(j,k) * ypct(j)
+c$$$ PB        y_flux_q(j,k) = y_flux_q(j,k) * ypct(j)
+          y_d_u(j,k) = y_d_u(j,k) * ypct(j)
+          y_d_v(j,k) = y_d_v(j,k) * ypct(j)
+c$$$ PB        y_flux_u(j,k) = y_flux_u(j,k) * ypct(j)
+c$$$ PB        y_flux_v(j,k) = y_flux_v(j,k) * ypct(j)
+        ENDDO
+      ENDDO
+
+
+      evap(:,nsrf) = - flux_q(:,1,nsrf)
+c
+      albe(:, nsrf) = 0.
+      alblw(:, nsrf) = 0.
+      snow(:, nsrf) = 0.
+      qsol(:, nsrf) = 0.
+      rugos(:, nsrf) = 0.
+      fluxlat(:,nsrf) = 0.
       DO j = 1, knon
-         ycoefh(j,k) = ycoefh(j,k) * ypct(j)
-         ycoefm(j,k) = ycoefm(j,k) * ypct(j)
-         y_d_t(j,k) = y_d_t(j,k) * ypct(j)
-         y_d_q(j,k) = y_d_q(j,k) * ypct(j)
-         y_flux_t(j,k) = y_flux_t(j,k) * ypct(j)
-         y_flux_q(j,k) = y_flux_q(j,k) * ypct(j)
-         y_d_u(j,k) = y_d_u(j,k) * ypct(j)
-         y_d_v(j,k) = y_d_v(j,k) * ypct(j)
-         y_flux_u(j,k) = y_flux_u(j,k) * ypct(j)
-         y_flux_v(j,k) = y_flux_v(j,k) * ypct(j)
-      ENDDO
-      ENDDO
-c
-      DO j = 1, knon
-      i = ni(j)
+         i = ni(j)
          d_ts(i,nsrf) = y_d_ts(j)
-         rugmer(i) = yrugm(j)
+         albe(i,nsrf) = yalb(j)
+         alblw(i,nsrf) = yalblw(j)
+         snow(i,nsrf) = ysnow(j)
+         qsol(i,nsrf) = yqsol(j)
+         rugos(i,nsrf) = yz0_new(j)
+         fluxlat(i,nsrf) = yfluxlat(j)
+c$$$ pb         rugmer(i) = yrugm(j)
+         IF (nsrf .EQ. is_oce) then 
+	       rugmer(i) = yrugm(j)
+               rugos(i,nsrf) = yrugm(i)
+          endif	
          cdragh(i) = cdragh(i) + ycoefh(j,1)
          cdragm(i) = cdragm(i) + ycoefm(j,1)
@@ -364,5 +535,13 @@
          zu1(i) = zu1(i) + yu1(j)
          zv1(i) = zv1(i) + yv1(j)
-      ENDDO
+      END DO
+c$$$ PB ajout pour soil
+      ftsoil(:,:,nsrf) = 0.
+      DO k = 1, nsoilmx
+        DO j = 1, knon
+          i = ni(j)
+          ftsoil(i, k, nsrf) = ytsoil(j,k)
+        END DO 
+      END DO 
 c
 #ifdef CRAY
@@ -377,39 +556,42 @@
          d_t(i,k) = d_t(i,k) + y_d_t(j,k)
          d_q(i,k) = d_q(i,k) + y_d_q(j,k)
-         flux_t(i,k) = flux_t(i,k) + y_flux_t(j,k)
-         flux_q(i,k) = flux_q(i,k) + y_flux_q(j,k)
+c$$$ PB        flux_t(i,k) = flux_t(i,k) + y_flux_t(j,k)
+c$$$         flux_q(i,k) = flux_q(i,k) + y_flux_q(j,k)
          d_u(i,k) = d_u(i,k) + y_d_u(j,k)
          d_v(i,k) = d_v(i,k) + y_d_v(j,k)
-         flux_u(i,k) = flux_u(i,k) + y_flux_u(j,k)
-         flux_v(i,k) = flux_v(i,k) + y_flux_v(j,k)
+c$$$  PB       flux_u(i,k) = flux_u(i,k) + y_flux_u(j,k)
+c$$$         flux_v(i,k) = flux_v(i,k) + y_flux_v(j,k)
          zcoefh(i,k) = zcoefh(i,k) + ycoefh(j,k)
       ENDDO
       ENDDO
 c
-cAA      IF (itr.GE.1) THEN
-cAA      DO it = 1, itr
-cAA      DO k = 1, klev
-cAA      DO j = 1, knon
-cAA         y_d_tr(j,k,it) = y_d_tr(j,k,it) * ypct(j)
-cAA      ENDDO
-cAA      ENDDO
-cAA      ENDDO
-cAA      DO j = 1, knon
-cAA      i = ni(j)
-cAA      DO it = 1, itr
-cAA      DO k = 1, klev
-cAA         d_tr(i,k,it) = d_tr(i,k,it) + y_d_tr(j,k,it)
-cAA      ENDDO
-cAA      ENDDO
-cAA      ENDDO
-cAA      ENDIF
-c
 99999 CONTINUE
 c
+C
+C On utilise les nouvelles surfaces
+C A rajouter: conservation de l'albedo
+C
+      rugos(:,is_oce) = rugmer
+      pctsrf = pctsrf_new
+
       RETURN
       END
-      SUBROUTINE clqh(knon,dtime,u1lay,v1lay,coef,t,q,ts,paprs,pplay,
-     e                delp,radsol,cal,beta,dif_grnd, gamt,gamq,
-     s                d_t, d_q, d_ts, flux_t, flux_q,dflux_s,dflux_l)
+      SUBROUTINE clqh(dtime,itime, date0,jour,debut,lafin,
+     e                rlon, rlat, cufi, cvfi, 
+     e                knon, nisurf, knindex, pctsrf,
+     $                soil_model,tsoil,
+     e                ok_veget, ocean, npas, nexca,
+     e                rmu0, rugos, rugoro,
+     e                u1lay,v1lay,coef,
+     e                t,q,ts,paprs,pplay,
+     e                delp,radsol,albedo,alblw,snow,qsol, 
+     e                precip_rain, precip_snow, fder, taux, tauy,
+     $                sollw, sollwdown, swnet,fluxlat, 
+     s                pctsrf_new, agesno,
+     s                d_t, d_q, d_ts, z0_new, 
+     s                flux_t, flux_q,dflux_s,dflux_l)
+
+      USE interface_surf
+
       IMPLICIT none
 c======================================================================
@@ -419,7 +601,13 @@
 #include "dimensions.h"
 #include "dimphy.h"
+#include "YOMCST.h"
+#include "YOETHF.h"
+#include "FCTTRE.h"
+#include "indicesol.h"
+#include "dimsoil.h"
 c Arguments:
       INTEGER knon
       REAL dtime              ! intervalle du temps (s)
+      real date0
       REAL u1lay(klon)        ! vitesse u de la 1ere couche (m/s)
       REAL v1lay(klon)        ! vitesse v de la 1ere couche (m/s)
@@ -428,15 +616,29 @@
 c                               vent (dV/dz); la premiere valeur
 c                               indique la valeur de Cdrag (sans unite)
-      REAL cal(klon)          ! Cp/cal indique la capacite calorifique
-c                               surfacique du sol
-      REAL beta(klon)         ! evap. reelle / evapotranspiration
-      REAL dif_grnd(klon)     ! coeff. diffusion vers le sol profond
       REAL t(klon,klev)       ! temperature (K)
       REAL q(klon,klev)       ! humidite specifique (kg/kg)
       REAL ts(klon)           ! temperature du sol (K)
+      REAL evap(klon)         ! evaporation au sol
       REAL paprs(klon,klev+1) ! pression a inter-couche (Pa)
       REAL pplay(klon,klev)   ! pression au milieu de couche (Pa)
       REAL delp(klon,klev)    ! epaisseur de couche en pression (Pa)
       REAL radsol(klon)       ! ray. net au sol (Solaire+IR) W/m2
+      REAL albedo(klon)       ! albedo de la surface
+      REAL alblw(klon)
+      REAL snow(klon)         ! hauteur de neige
+      REAL qsol(klon)         ! humidite de la surface
+      real precip_rain(klon), precip_snow(klon)
+      REAL agesno(klon)
+      REAL rugoro(klon)
+      integer jour            ! jour de l'annee en cours
+      real rmu0(klon)         ! cosinus de l'angle solaire zenithal
+      real rugos(klon)        ! rugosite
+      integer knindex(klon)
+      real pctsrf(klon,nbsrf)
+      real rlon(klon), rlat(klon), cufi(klon), cvfi(klon)
+      logical ok_veget 
+      character*6 ocean
+      integer npas, nexca
+
 c
       REAL d_t(klon,klev)     ! incrementation de "t"
@@ -449,5 +651,4 @@
       REAL dflux_s(klon) ! derivee du flux sensible dF/dTs
       REAL dflux_l(klon) ! derivee du flux latent dF/dTs
-      REAL dflux_g(klon) ! derivee du flux du sol profond dF/dTs
 c======================================================================
       REAL t_grnd  ! temperature de rappel pour glace de mer
@@ -457,11 +658,4 @@
 c======================================================================
       INTEGER i, k
-      REAL zx_a
-      REAL zx_b
-      REAL zx_qs
-      REAL zx_dq_s_dh
-      REAL zx_h_grnd
-      REAL zx_cq0(klon)
-      REAL zx_dq0(klon)
       REAL zx_cq(klon,klev)
       REAL zx_dq(klon,klev)
@@ -471,11 +665,7 @@
       REAL zx_buf2(klon)
       REAL zx_coef(klon,klev)
-      REAL zx_q_0(klon)
-      REAL zx_h_ts(klon)
-      REAL zx_sl(klon)
       REAL local_h(klon,klev) ! enthalpie potentielle
       REAL local_q(klon,klev)
       REAL local_ts(klon)
-      REAL zx_alf1(klon), zx_alf2(klon) !valeur ambiante par extrapola.
       REAL psref(klon) ! pression de reference pour temperature potent.
       REAL zx_pkh(klon,klev), zx_pkf(klon,klev)
@@ -488,15 +678,54 @@
       REAL zdelz
 c======================================================================
-      REAL zcor, zdelta, zcvm5
-#include "YOMCST.h"
-#include "YOETHF.h"
-#include "FCTTRE.h"
-c======================================================================
+      logical contreg
+      parameter (contreg=.true.)
+c======================================================================
+c Rajout pour l'interface
+      integer itime
+      integer nisurf
+      logical debut, lafin
+      real zlev1(klon)
+      real fder(klon), taux(klon), tauy(klon)
+      real temp_air(klon), spechum(klon)
+      real epot_air(klon), ccanopy(klon)
+      real tq_cdrag(klon), petAcoef(klon), peqAcoef(klon)
+      real petBcoef(klon), peqBcoef(klon)
+      real sollw(klon), sollwdown(klon), swnet(klon), swdown(klon)
+      real p1lay(klon)
+c$$$C PB ajout pour soil
+      LOGICAL soil_model
+      REAL tsoil(klon, nsoilmx)
+
+! Parametres de sortie
+      real fluxsens(klon), fluxlat(klon)
+      real tsol_rad(klon), tsurf_new(klon), alb_new(klon)
+      real emis_new(klon), z0_new(klon)
+      real pctsrf_new(klon,nbsrf)
+      
+c
+
+      if (.not. contreg) then
+        do k = 2, klev
+          do i = 1, knon
+            gamq(i,k) = 0.0
+            gamt(i,k) = 0.0
+          enddo
+        enddo
+      else
+        do k = 3, klev
+          do i = 1, knon
+            gamq(i,k)= 0.0
+            gamt(i,k)=  -1.0e-03
+          enddo
+        enddo
+        do i = 1, knon
+          gamq(i,2) = 0.0
+          gamt(i,2) = -2.5e-03
+        enddo
+      endif
+
       DO i = 1, knon
          psref(i) = paprs(i,1) !pression de reference est celle au sol
          local_ts(i) = ts(i)
-ccc         zx_alf1(i) = (paprs(i,1)-pplay(i,2))/(pplay(i,1)-pplay(i,2))
-         zx_alf1(i) = 1.0
-         zx_alf2(i) = 1.0 - zx_alf1(i)
       ENDDO
       DO k = 1, klev
@@ -511,10 +740,4 @@
 c Convertir les coefficients en variables convenables au calcul:
 c
-      DO i = 1, knon
-         zx_coef(i,1) = coef(i,1)
-     .                 * (1.0+SQRT(u1lay(i)**2+v1lay(i)**2))
-     .                 * pplay(i,1)/(RD*t(i,1))
-         zx_coef(i,1) = zx_coef(i,1) * dtime*RG
-      ENDDO
 c
       DO k = 2, klev
@@ -535,31 +758,4 @@
          z_gamah(i,k) = gamt(i,k) * zdelz *RCPD * zx_pkh(i,k)
       ENDDO
-      ENDDO
-c======================================================================
-      DO i = 1, knon
-         IF (thermcep) THEN
-           zdelta=MAX(0.,SIGN(1.,rtt-local_ts(i)))
-           zcvm5 = R5LES*RLVTT*(1.-zdelta) + R5IES*RLSTT*zdelta
-           zcvm5 = zcvm5 / RCPD / (1.0+RVTMP2*q(i,1))
-           zx_qs= r2es * FOEEW(local_ts(i),zdelta)/paprs(i,1)
-           zx_qs=MIN(0.5,zx_qs)
-           zcor=1./(1.-retv*zx_qs)
-           zx_qs=zx_qs*zcor
-           zx_dq_s_dh = FOEDE(local_ts(i),zdelta,zcvm5,zx_qs,zcor)
-     .                 /RLVTT / zx_pkh(i,1)
-         ELSE
-           IF (local_ts(i).LT.t_coup) THEN
-              zx_qs = qsats(local_ts(i)) / paprs(i,1)
-              zx_dq_s_dh = dqsats(local_ts(i),zx_qs)/RLVTT
-     .                    / zx_pkh(i,1)
-           ELSE
-              zx_qs = qsatl(local_ts(i)) / paprs(i,1)
-              zx_dq_s_dh = dqsatl(local_ts(i),zx_qs)/RLVTT
-     .                    / zx_pkh(i,1)
-           ENDIF
-         ENDIF
-c
-         zx_dq0(i) = zx_dq_s_dh
-         zx_cq0(i) = zx_qs -zx_dq_s_dh *local_ts(i)*RCPD*zx_pkh(i,1)
       ENDDO
       DO i = 1, knon
